/**
 * Status Code Constants

   Copyright (c) 2003, Gumbynet & Damien Gardner Jnr
   All rights reserved.

   Redistribution and use in source and binary forms, with or without modification,
   are permitted provided that the following conditions are met:

   * Redistributions of source code must retain the above copyright notice, this list
       of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice, this list
       of conditions and the following disclaimer in the documentation and/or other
       materials provided with the distribution.
   * Neither the name of GumbyNet nor the names of its contributors may be used to
       endorse or promote products derived from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
   OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
   AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
   OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
   OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.gumbynet.carnivore.constants;

public class StatusCodes {
    public static final StatusCodes NOREPORT = new StatusCodes(new Integer(0), "BLANK");
    public static final StatusCodes GREEN = new StatusCodes(new Integer(1), "GREEN");
    public static final StatusCodes ORANGE = new StatusCodes(new Integer(2), "ORANGE");
    public static final StatusCodes RED = new StatusCodes(new Integer(3), "RED");

    private final Integer myCode; // for debug only
    private final String myName; // for debug only

    private StatusCodes(Integer code, String name) {
        myCode = code;
        myName = name;
    }

    public Integer getCode() {
        return myCode;
    }
    public String toString() {
        return myName;
    }
}
