package org.gumbynet.carnivore.helpers;

import org.gumbynet.carnivore.objects.HostLogEntry;
import org.gumbynet.carnivore.objects.ServiceTestHelper;
import org.gumbynet.carnivore.constants.StatusCodes;

import java.net.Socket;
import java.io.*;

/**
 * SMTP Helper

   Copyright (c) 2003, Gumbynet & Damien Gardner Jnr
   All rights reserved.

   Redistribution and use in source and binary forms, with or without modification,
   are permitted provided that the following conditions are met:

   * Redistributions of source code must retain the above copyright notice, this list
       of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice, this list
       of conditions and the following disclaimer in the documentation and/or other
       materials provided with the distribution.
   * Neither the name of GumbyNet nor the names of its contributors may be used to
       endorse or promote products derived from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
   OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
   AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
   OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
   OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
public class FTPHelper implements ServiceTestHelper {


    public HostLogEntry testService (String HostIP) {

        String strReturnString = "";
        Socket s;
        HostLogEntry hle = new HostLogEntry();
        BufferedReader br;
        try {
            // Open a connection
            s = new Socket(HostIP, 21);

        } catch (IOException e) {
//            e.printStackTrace();  //To change body of catch statement use Options | File Templates.
            hle.setStatusCode(StatusCodes.RED.getCode().intValue());
            hle.setStatusTitle("Could not connect to "+HostIP);
            hle.setStatusMessage("Couldn't Connect!");
            return hle;

        }


        try {
            br = new BufferedReader(new InputStreamReader(s.getInputStream()));
            strReturnString = br.readLine();
        } catch (IOException e) {
//            e.printStackTrace();  //To change body of catch statement use Options | File Templates.
            hle.setStatusCode(StatusCodes.ORANGE.getCode().intValue());
            hle.setStatusTitle("Connected to "+HostIP+" but couldn't get welcome message");
            hle.setStatusMessage("Eeek!!");
            return hle;

        }

        hle.setStatusCode(StatusCodes.GREEN.getCode().intValue());
        hle.setStatusTitle(strReturnString);

        strReturnString = "";
        try {
            OutputStreamWriter osw = new OutputStreamWriter(s.getOutputStream());
            osw.write("QUIT\r\n");
            osw.flush();
            strReturnString = br.readLine();
            s.close();
        } catch (IOException e) {
//            e.printStackTrace();  //To change body of catch statement use Options | File Templates.
        }

        if (strReturnString.length()>0) {
            hle.setStatusMessage(strReturnString);
        }


        return hle;
    }

}
