package org.gumbynet.carnivore.helpers;

import org.gumbynet.carnivore.objects.ServiceTestHelper;
import org.gumbynet.carnivore.objects.HostLogEntry;
import org.gumbynet.carnivore.constants.StatusCodes;

import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * Created by IntelliJ IDEA.
 * User: damien
 * Date: 7/12/2004
 * Time: 10:12:37
     Copyright (c) 2003, Gumbynet & Damien Gardner Jnr
     All rights reserved.

     Redistribution and use in source and binary forms, with or without modification,
     are permitted provided that the following conditions are met:

     * Redistributions of source code must retain the above copyright notice, this list
         of conditions and the following disclaimer.
     * Redistributions in binary form must reproduce the above copyright notice, this list
         of conditions and the following disclaimer in the documentation and/or other
         materials provided with the distribution.
     * Neither the name of GumbyNet nor the names of its contributors may be used to
         endorse or promote products derived from this software without specific prior written permission.

     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
     OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
     AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
     OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
     CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
     SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
     THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
     OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 */
public class PINGLinHelper implements ServiceTestHelper {

    public HostLogEntry testService(String HostIP) {
        String strPacketsReceivedLine = null;
        String strPacketsRTT = null;
        int packetsReceived = 0;
        HostLogEntry hle = new HostLogEntry();
        Process p = null;
        try {
            Runtime rt = Runtime.getRuntime();

            // Start the ping process
            p = rt.exec("ping -c 3 "+HostIP);
            // Setup a buffered reader..
            BufferedReader brStream = new BufferedReader(new InputStreamReader(p.getInputStream()));

            String strTempLine;
            brStream.readLine();
            // Until we've finished :)
            while ((strTempLine = brStream.readLine())!=null) {
                strTempLine.trim();
                if (strTempLine.startsWith("3 packets transmitted"))
                    strPacketsReceivedLine = strTempLine;
                else if (strTempLine.startsWith("rtt min/avg/max"))
                    strPacketsRTT = strTempLine;
                else if (strTempLine.startsWith("round-trip min/avg/max"))
                    strPacketsRTT = strTempLine;
            }

            // ok, now get the number of received packets..
            strPacketsReceivedLine = strPacketsReceivedLine.substring(strPacketsReceivedLine.indexOf(",")+2);
            strPacketsReceivedLine = strPacketsReceivedLine.substring(0, strPacketsReceivedLine.indexOf(" "));
            packetsReceived = Integer.parseInt(strPacketsReceivedLine);

            if (packetsReceived==3) {
                // totally successful
                hle.setStatusCode(StatusCodes.GREEN.getCode().intValue());
                hle.setStatusTitle("Connection OK");
                if (strPacketsRTT!=null)
                    hle.setStatusMessage(strPacketsRTT);
            } else if (packetsReceived>0) {
                hle.setStatusCode(StatusCodes.ORANGE.getCode().intValue());
                hle.setStatusTitle("WARNING - lost "+(3-packetsReceived)+" ping(s) during testing");
                if (strPacketsRTT!=null)
                    hle.setStatusMessage(strPacketsRTT);
            } else {
                hle.setStatusCode(StatusCodes.RED.getCode().intValue());
                hle.setStatusTitle("ERROR: Couldn't contact host!");
                hle.setStatusMessage("Couldn't contact host "+HostIP+" after 3 attempts");
            }
        } catch (Exception e) {
        	e.printStackTrace();
        } finally {
            try {
                p.destroy();
            } catch (Exception e2) {

            }
        }



        return hle;  //To change body of implemented methods use File | Settings | File Templates.
    }


}
